c	Copyright (C) 2008-2013 and onwards  Nuno Pessoa Barradas
c	Campus Tecnolgico e Nuclear / Instituto Superior Tcnico
c	E.N. 10, Apartado 21, 2686-953 Sacavm, Portugal
c	Tel. +351 219946150 e-mail: nunoni@ctn.ist.utl.pt

c	This program is free software: you can redistribute it and/or modify
c	it under the terms of the GNU General Public License as published by
c	the Free Software Foundation, either version 3 of the License, or
c	any later version.

c	This program is distributed in the hope that it will be useful,
c	but WITHOUT ANY WARRANTY; without even the implied warranty of
c	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c	GNU General Public License for more details.

c	You should have received a copy of the GNU General Public License
c	along with this program.  If not, see <http://www.gnu.org/licenses/>.

c	The copyright owner (N.P. Barradas) is also the author of the non-GPL code NDF.
c	These routines are also used by NDF under a special agreement.

c     Release 1.02 13 february 2013
c-----------------------------------------------------------------------
	subroutine allocate_idf_tags
      !DEC$ ATTRIBUTES DLLEXPORT::allocate_idf_tags
c     routine that allocates all the required variables for one single sample from file idf_file
	use IDFCOM
	implicit none
	integer i,j,k,k1
c	type(idf_sample)::sample
c-----------------------------------------------------------------------
      idf_ok=.false.
      idf_error=' '
      if (verbosity_IDF) then
      write(*,*)'dimension',idfnelements, idfnmolecules,nlayers_idf,idfnspectra    !,nnr_max_idf
      write(*,*)'idfnspectra,idfnfoillayers',idfnspectra,idfnfoillayers
      write(*,*)'npbp_element_idf npbp_idf nlayerspbpmax_idf',npbp_element_idf,npbp_idf(1:npbp_element_idf),nlayerspbpmax_idf
      do i=1,npbp_element_idf
      write(*,*)'nlayerspbp_idf',i,nlayerspbp_idf(i,1:npbp_idf(i))
      end do
      write(*,*)'ndatapoints_idf',ndatapoints_idf(1:idfnspectra)
      write(*,*)'datadimensionx_idf',datadimensionx_idf(1:idfnspectra)
      write(*,*)'datadimensiony_idf',datadimensiony_idf(1:idfnspectra)
      do i=1,idfnspectra
      write(*,*)'sim nsimulation_idf',i,nsimulation_idf(i)
      do j=1,nsimulation_idf(i)
      write(*,*)'sim nsimpoints_idf',':',nsimpoints_idf(i,j)
      write(*,*)'sim simdimensionx_idf',':',simdimensionx_idf(i,j)
      write(*,*)'sim simdimensiony_idf',':',simdimensiony_idf(i,j)
      end do
      end do
      write(*,*)'nslitsbeforesample_idf ',nslitsbeforesample_idf(1:idfnspectra)
      write(*,*)'nslitsaftersample_idf ',nslitsaftersample_idf(1:idfnspectra)
      write(*,*)'nbeamfoillayers_idf ',nbeamfoillayers_idf(1:idfnspectra)
      write(*,*)'nbeamfoilels_idf ',nbeamfoilels_idf(1:idfnspectra,1:2)
      write(*,*)'nstoppingfoillayers_idf ',nstoppingfoillayers_idf(1:idfnspectra)
      write(*,*)'nstoppingfoilels_idf ',nstoppingfoilels_idf(1:idfnspectra,1:2)
      write(*,*)'ndeadlayer_idf ',ndeadlayer_idf(1:idfnspectra)
      write(*,*)'ndeadlayerels_idf ',ndeadlayerels_idf(1:idfnspectra)
      write(*,*)'nentrancewindow_idf ',nentrancewindow_idf(1:idfnspectra)
      write(*,*)'nentrancewindowels_idf ',nentrancewindowels_idf(1:idfnspectra,1:2)
      write(*,*)'ndetectorlayers_idf ',ndetectorlayers_idf(1:idfnspectra)
      write(*,*)'ndetectorlayersels_idf ',ndetectorlayersels_idf(1:idfnspectra,1:2)
      write(*,*)'ntofstartfoil_idf ',ntofstartfoil_idf(1:idfnspectra)
      write(*,*)'ntofstartfoilels_idf ',ntofstartfoilels_idf(1:idfnspectra,1:2)
      write(*,*)'ntofstopfoil_idf ',ntofstopfoil_idf(1:idfnspectra)
      write(*,*)'ntofstopfoilels_idf ',ntofstopfoilels_idf(1:idfnspectra,1:2)
      write(*,*)'ndetectorefficiency_idf ',ndetectorefficiency_idf(1:idfnspectra)
      write(*,*)'ndetectorefficiencyentries_idf ',ndetectorefficiencyentries_idf(1:idfnspectra,1:2)
      write(*,*)'ndetectorresolution_idf ',ndetectorresolution_idf(1:idfnspectra)
      do i=1,idfnspectra
      write(*,*)'nresolutionparameter_idf ',i,(nresolutionparameter_idf(i,j),j=1,ndetectorresolution_idf(i))
      end do
      write(*,*)'nenergycalibration_idf ',nenergycalibration_idf(1:idfnspectra)
      do i=1,idfnspectra
      write(*,*)'ncalibrationparameter_idf ',i,(ncalibrationparameter_idf(i,j),j=1,nenergycalibration_idf(i))
      end do
      write(*,*)'nreaction_idf ',nreaction_idf(1:idfnspectra)
      write(*,*)'nsimulation_idf ',nsimulation_idf(1:idfnspectra)
      do i=1,idfnspectra
      write(*,*)'ncrosssection_idf ',i,':',ncrosssection_idf(i,1:nsimulation_idf(i))
      do j=1,nsimulation_idf(i)
      write(*,*)'ncrosssectionpoints_idf ',i,j,':',ncrosssectionpoints_idf(i,j,1:ncrosssection_idf(i,j))
      end do
      end do
      do i=1,idfnspectra
      write(*,*)'nstoppingpower_idf ',i,':',nstoppingpower_idf(i,1:nsimulation_idf(i))
      do j=1,nsimulation_idf(i)
      write(*,*)'nstoppingpowerpoints_idf ',i,j,':',nstoppingpowerpoints_idf(i,j,1:nstoppingpower_idf(i,j))
      end do
      end do
      do i=1,idfnspectra
      write(*,*)'nenergyspread_idf ',i,':',nenergyspread_idf(i,1:nsimulation_idf(i))
      do j=1,nsimulation_idf(i)
      write(*,*)'nenergyspreadpoints_idf ',i,j,':',nenergyspreadpoints_idf(i,j,1:nenergyspread_idf(i,j))
      end do
      end do
c      pause 'entered allocate_idf_tags based on dimensions above'
      end if

	idf_realquantity_null%units=' '
	idf_realquantity_null%mode=' '
	idf_realquantity_null%quantity=' '
	idf_realquantity_null%value=0.
	idf_realquantity_null%uncertainty=0.
	idf_realquantity_null%uncertaintyA=0.
	idf_realquantity_null%uncertaintyB=0.
	idf_realquantity_null%uncertaintyplus=0.
	idf_realquantity_null%uncertaintyminus=0.

      idf_shape_aux%shape=' '
      idf_shape_aux%l1=idf_realquantity_null
      idf_shape_aux%l2=idf_realquantity_null
      idf_shape_aux%l3=idf_realquantity_null

c     sample usersnotes and attributes
	if (allocated(sample%usersnotes%notes%note)) deallocate(sample%usersnotes%notes%note)
	if (sample%usersnotes%notes%n.gt.0) then
	  allocate(sample%usersnotes%notes%note(sample%usersnotes%notes%n))
	  if (.not.allocated(sample%usersnotes%notes%note)) then
	    idf_error='problem allocating sample%usersnotes%notes%note'
	    goto 1000
	  end if
	  sample%usersnotes%notes%note=' '
	end if
	if (allocated(sample%usersnotes%users%user)) deallocate(sample%usersnotes%users%user)
	if (sample%usersnotes%users%n.gt.0) then
	  allocate(sample%usersnotes%users%user(sample%usersnotes%users%n))
	  if (.not.allocated(sample%usersnotes%users%user)) then
	    idf_error='problem allocating sample%usersnotes%users%user'
	    goto 1000
	  end if
	  sample%usersnotes%users%user=' '
	end if

c     description
      sample%description=' '

c     elementsandmolecules
	sample%elementsandmolecules%nelements=idfnelements
	sample%elementsandmolecules%nmolecules=idfnmolecules
	if (allocated(sample%elementsandmolecules%elements%element)) deallocate(sample%elementsandmolecules%elements%element)
	if (idfnelements.gt.0) then
	  allocate(sample%elementsandmolecules%elements%element(idfnelements))
	  if (.not.allocated(sample%elementsandmolecules%elements%element)) then
	    idf_error='problem allocating sample%elementsandmolecules%elements%element'
	    goto 1000
	  end if
	  sample%elementsandmolecules%elements%element%name=' '
	  sample%elementsandmolecules%elements%element%density=idf_realquantity_null
	end if
	if (allocated(sample%elementsandmolecules%molecules%molecule)) deallocate(sample%elementsandmolecules%molecules%molecule)
	if (idfnmolecules.gt.0) then
	  allocate(sample%elementsandmolecules%molecules%molecule(idfnmolecules))
	  if (.not.allocated(sample%elementsandmolecules%molecules%molecule)) then
	    idf_error='problem allocating sample%elementsandmolecules%molecules%molecule'
	    goto 1000
	  end if
	  sample%elementsandmolecules%molecules%molecule%name=' '
	  sample%elementsandmolecules%molecules%molecule%density=idf_realquantity_null
	end if

c     structure

      sample%structure%crystalstructure=' '

c     layeredstructure
c     layer
      sample%structure%layeredstructure%nlayers=nlayers_idf
      sample%structure%layeredstructure%layers%n=nlayers_idf
      if (allocated(sample%structure%layeredstructure%layers%layer)) deallocate(sample%structure%layeredstructure%layers%layer)
	if (nlayers_idf.gt.0) then
	allocate(sample%structure%layeredstructure%layers%layer(nlayers_idf))
	if (.not.allocated(sample%structure%layeredstructure%layers%layer)) then
	  idf_error='problem allocating sample%structure%layeredstructure%layers%layer'
	  goto 1000
	end if
	sample%structure%layeredstructure%equationoverlays=' '
      do i=1,nlayers_idf
c     non-allocatable variables
      sample%structure%layeredstructure%layers%layer(i)%layerthickness=idf_realquantity_null
      sample%structure%layeredstructure%layers%layer(i)%layeruniformity=idf_realquantity_null
      sample%structure%layeredstructure%layers%layer(i)%layerdensity=idf_realquantity_null
c     layerelement
      if (allocated(sample%structure%layeredstructure%layers%layer(i)%layerelements%layerelement)) 
     +deallocate(sample%structure%layeredstructure%layers%layer(i)%layerelements%layerelement)
      sample%structure%layeredstructure%layers%layer(i)%layerelements%n=0
	if (idfnelements.gt.0) then
	allocate(sample%structure%layeredstructure%layers%layer(i)%layerelements%layerelement(idfnelements))
	if (.not.allocated(sample%structure%layeredstructure%layers%layer(i)%layerelements%layerelement)) then
	  idf_error='problem allocating sample%structure%layeredstructure%layers%layer%layerelements%layerelement'
	  goto 1000
	end if
	sample%structure%layeredstructure%layers%layer(i)%layerelements%layerelement%name=' '
	sample%structure%layeredstructure%layers%layer(i)%layerelements%layerelement%concentration=idf_realquantity_null
	end if
c     layermolecule
      if (allocated(sample%structure%layeredstructure%layers%layer(i)%layermolecules%layermolecule)) 
     +deallocate(sample%structure%layeredstructure%layers%layer(i)%layermolecules%layermolecule)
      sample%structure%layeredstructure%layers%layer(i)%layermolecules%n=0
c      write(*,*)'allocate',i,sample%structure%layeredstructure%layers%layer(i)%layermolecules%n
	if (idfnmolecules.gt.0) then
	allocate(sample%structure%layeredstructure%layers%layer(i)%layermolecules%layermolecule(idfnmolecules))
	if (.not.allocated(sample%structure%layeredstructure%layers%layer(i)%layermolecules%layermolecule)) then
	  idf_error='problem allocating sample%structure%layeredstructure%layers%layer%layermolecules%layermolecule'
	  goto 1000
	end if
	sample%structure%layeredstructure%layers%layer(i)%layermolecules%layermolecule%name=' '
	sample%structure%layeredstructure%layers%layer(i)%layermolecules%layermolecule%concentration=idf_realquantity_null
	end if
	end do
	end if
	sample%structure%layeredstructure%equationoverlays=' '
	sample%structure%layeredstructure%roughness=' '

c     pointbypointstructure
c     pbp_aux
	pbp_aux%xaxis%axisname=' '
	pbp_aux%xaxis%axisunit=' '
	pbp_aux%xerroraxis%axisname=' '
	pbp_aux%xerroraxis%axisunit=' '
	pbp_aux%yaxis%axisname=' '
	pbp_aux%yaxis%axisunit=' '
	pbp_aux%yerroraxis%axisname=' '
	pbp_aux%yerroraxis%axisunit=' '
	pbp_aux%ndfidf_iong=0
	pbp_aux%n=0
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%x)
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%xerror)
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%y)
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%yerror)
      if (nlayerspbpmax_idf.gt.0) then
        allocate(pbp_aux%x(nlayerspbpmax_idf))
        allocate(pbp_aux%xerror(nlayerspbpmax_idf))
        allocate(pbp_aux%y(nlayerspbpmax_idf))
        allocate(pbp_aux%yerror(nlayerspbpmax_idf))
        pbp_aux%x=0.
        pbp_aux%xerror=0.
        pbp_aux%y=0.
        pbp_aux%yerror=0.
      end if
c      write(*,*)'allocate npbp_element_idf npbp_max_idf',npbp_element_idf,npbp_max_idf
c      pause
c     element
      sample%structure%pointbypointstructure%n=0
      if (allocated(sample%structure%pointbypointstructure%pbpelement))deallocate(sample%structure%pointbypointstructure%pbpelement)
	if (npbp_element_idf.gt.0) then
      sample%structure%pointbypointstructure%n=npbp_element_idf
	allocate(sample%structure%pointbypointstructure%pbpelement(npbp_element_idf))
	if (.not.allocated(sample%structure%pointbypointstructure%pbpelement)) then
	  idf_error='problem allocating sample%structure%pointbypointstructure%pbpelement'
	  goto 1000
	end if
	end if
c     npbp_element_idf is the number of elements with pbp profile
	do i=1,npbp_element_idf
	  sample%structure%pointbypointstructure%pbpelement(i)%n=0
	  sample%structure%pointbypointstructure%pbpelement(i)%elementname=' '
c       pbp
        if (allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp)) 
     +  deallocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp)
	  if (npbp_idf(i).gt.0) then
	  sample%structure%pointbypointstructure%pbpelement(i)%n=npbp_idf(i)
	  allocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp(npbp_idf(i)))
	  if (.not.allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp)) then
	    idf_error='problem allocating sample%structure%pointbypointstructure%pbpelement(i)%pbp'
	    goto 1000
	  end if
	  end if
c	  npbp_idf(i) is the number of pbp profiles for one given element
	  do j=1,npbp_idf(i)
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xaxis%axisname=' '
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xaxis%axisunit=' '
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerroraxis%axisname=' '
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerroraxis%axisunit=' '
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yaxis%axisname=' '
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yaxis%axisunit=' '
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerroraxis%axisname=' '
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerroraxis%axisunit=' '
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n=0
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%ndfidf_iong=0
          if (allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x)) 
     +    deallocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x)
	    if (nlayerspbp_idf(i,j).gt.0) then
          sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n=nlayerspbp_idf(i,j)
	    allocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x(nlayerspbp_idf(i,j)))
	    if (.not.allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x)) then
	      idf_error='problem allocating sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x'
	      goto 1000
	    end if
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x=0.
	    end if
          if (allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerror)) 
     +    deallocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerror)
	    if (nlayerspbp_idf(i,j).gt.0) then
	    allocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerror(nlayerspbp_idf(i,j)))
	    if (.not.allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerror)) then
	      idf_error='problem allocating sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerror'
	      goto 1000
	    end if
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerror=0.
	    end if
          if (allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%y)) 
     +    deallocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%y)
	    if (nlayerspbp_idf(i,j).gt.0) then
	    allocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%y(nlayerspbp_idf(i,j)))
	    if (.not.allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%y)) then
	      idf_error='problem allocating sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%y'
	      goto 1000
	    end if
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%y=' '
	    end if
          if (allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerror)) 
     +    deallocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerror)
	    if (nlayerspbp_idf(i,j).gt.0) then
	    allocate(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerror(nlayerspbp_idf(i,j)))
	    if (.not.allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerror)) then
	      idf_error='problem allocating sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerror'
	      goto 1000
	    end if
	    sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerror=' '
	    end if
	  end do
	end do

c     spectrum
      sample%spectra%n=0
      if (allocated(sample%spectra%spectrum)) deallocate(sample%spectra%spectrum)
	if (idfnspectra.gt.0) then
      sample%spectra%n=idfnspectra
	allocate(sample%spectra%spectrum(idfnspectra))
	if (.not.allocated(sample%spectra%spectrum)) then
	  idf_error='problem allocating sample%spectra%spectrum'
	  goto 1000
	end if
	end if

c     spectrum - log and environment
      sample%spectra%spectrum(:)%log%realtime=' '
      sample%spectra%spectrum(:)%log%livetime=' '
      sample%spectra%spectrum(:)%log%deadtime=' '
      sample%spectra%spectrum(:)%log%starttime=' '
      sample%spectra%spectrum(:)%log%stoptime=' '
      sample%spectra%spectrum(:)%environment%temperature=idf_realquantity_null
      sample%spectra%spectrum(:)%environment%pressure=idf_realquantity_null

c     spectrum - beam
      sample%spectra%spectrum(:)%beam%beamparticle=' '
      sample%spectra%spectrum(:)%beam%beamZ=0
      sample%spectra%spectrum(:)%beam%beammass=idf_realquantity_null
      sample%spectra%spectrum(:)%beam%beamenergy=idf_realquantity_null
      sample%spectra%spectrum(:)%beam%beamenergyspread=idf_realquantity_null
      do i=1,idfnspectra
      if (allocated(sample%spectra%spectrum(i)%beam%beamchargestate%x))
     +deallocate(sample%spectra%spectrum(i)%beam%beamchargestate%x)
      if (allocated(sample%spectra%spectrum(i)%beam%beamchargestate%x))
     +deallocate(sample%spectra%spectrum(i)%beam%beamchargestate%xerror)
      if (allocated(sample%spectra%spectrum(i)%beam%beamchargestate%x))
     +deallocate(sample%spectra%spectrum(i)%beam%beamchargestate%y)
      if (allocated(sample%spectra%spectrum(i)%beam%beamchargestate%x))
     +deallocate(sample%spectra%spectrum(i)%beam%beamchargestate%yerror)
      sample%spectra%spectrum(i)%beam%beamchargestate%n=nbeamchargestate_idf(i)
      if (nbeamchargestate_idf(i).gt.0) then
        allocate(sample%spectra%spectrum(i)%beam%beamchargestate%x(nbeamchargestate_idf(i)))
        allocate(sample%spectra%spectrum(i)%beam%beamchargestate%xerror(nbeamchargestate_idf(i)))
        allocate(sample%spectra%spectrum(i)%beam%beamchargestate%y(nbeamchargestate_idf(i)))
        allocate(sample%spectra%spectrum(i)%beam%beamchargestate%yerror(nbeamchargestate_idf(i)))
        sample%spectra%spectrum(i)%beam%beamchargestate%n=nbeamchargestate_idf(i)
        sample%spectra%spectrum(i)%beam%beamchargestate%x=0.
        sample%spectra%spectrum(i)%beam%beamchargestate%xerror=0.
        sample%spectra%spectrum(i)%beam%beamchargestate%y=0.
        sample%spectra%spectrum(i)%beam%beamchargestate%yerror=0.
      end if
      end do
      sample%spectra%spectrum(:)%beam%beamfluence=idf_realquantity_null
      sample%spectra%spectrum(:)%beam%beamcurrent=idf_realquantity_null
      sample%spectra%spectrum(:)%beam%beamangularspread=idf_realquantity_null
c     beam shape
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%beam%beamshape=idf_shape_aux
      end do
c     slit before sample
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%beam%slitsbeforesample%n=0
      if (allocated(sample%spectra%spectrum(i)%beam%slitsbeforesample%slit)) 
     +deallocate(sample%spectra%spectrum(i)%beam%slitsbeforesample%slit)
	if (nslitsbeforesample_idf(i).gt.0) then
	sample%spectra%spectrum(i)%beam%slitsbeforesample%n=nslitsbeforesample_idf(i)
	allocate(sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(nslitsbeforesample_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%beam%slitsbeforesample%slit)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%beam%slitsbeforesample%slit'
	  goto 1000
	end if
	sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(:)%slitshape=idf_shape_aux
	sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(:)%slitdistancetosample=idf_realquantity_null
	end if
	end do
c     beamfoil
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%beam%beamfoil%foildistancetosample=idf_realquantity_null
      sample%spectra%spectrum(i)%beam%beamfoil%foillayers%n=0
      if (allocated(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer))
     +deallocate(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer)
	if (nbeamfoillayers_idf(i).gt.0) then
      sample%spectra%spectrum(i)%beam%beamfoil%foillayers%n=nbeamfoillayers_idf(i)
	allocate(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(nbeamfoillayers_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer'
	  goto 1000
	end if
	end if
      do j=1,nbeamfoillayers_idf(i)
c     layerelement
      sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%n=0
      if (allocated(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%layerelement)) 
     +deallocate(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%layerelement)
	if (nbeamfoilels_idf(i,j).gt.0) then
      sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%n=nbeamfoilels_idf(i,j)
	allocate(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%layerelement(nbeamfoilels_idf(i,j)))
	if (.not.allocated(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%layerelement)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer%layerelements%layerelement'
	  goto 1000
	end if
	end if
	sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerthickness=idf_realquantity_null
	sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layeruniformity=idf_realquantity_null
	sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerdensity=idf_realquantity_null
	end do
	end do

c     spectrum - geometry
      sample%spectra%spectrum(:)%geometry%geometrytype=' '
      sample%spectra%spectrum(:)%geometry%incidenceangle=idf_realquantity_null
      sample%spectra%spectrum(:)%geometry%scatteringangle=idf_realquantity_null
      sample%spectra%spectrum(:)%geometry%exitangle=idf_realquantity_null
      sample%spectra%spectrum(:)%geometry%spot%shape=' '
      sample%spectra%spectrum(:)%geometry%spot%l1=idf_realquantity_null
      sample%spectra%spectrum(:)%geometry%spot%l2=idf_realquantity_null

c     spectrum - instrument
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%instrument%ionsource=' '
      sample%spectra%spectrum(i)%instrument%accelerator=' '
      sample%spectra%spectrum(i)%instrument%beamline=' '
      sample%spectra%spectrum(i)%instrument%chamber=' '
      sample%spectra%spectrum(i)%instrument%sampleholder=' '
	end do

c     spectrum - detection

c     slitsaftersample
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%detection%slitsaftersample%n=0
      if (allocated(sample%spectra%spectrum(i)%detection%slitsaftersample%slit)) 
     +deallocate(sample%spectra%spectrum(i)%detection%slitsaftersample%slit)
	if (nslitsaftersample_idf(i).gt.0) then
      sample%spectra%spectrum(i)%detection%slitsaftersample%n=nslitsaftersample_idf(i)
	allocate(sample%spectra%spectrum(i)%detection%slitsaftersample%slit(nslitsaftersample_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%slitsaftersample%slit)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%slitsaftersample%slit'
	  goto 1000
	end if
	sample%spectra%spectrum(i)%detection%slitsaftersample%slit(:)%slitshape=idf_shape_aux
	sample%spectra%spectrum(i)%detection%slitsaftersample%slit(:)%slitdistancetosample=idf_realquantity_null
	end if
	end do
c     stoppingfoil
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%detection%stoppingfoil%foildistancetosample=idf_realquantity_null
      sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%n=0
      if (allocated(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer))
     +deallocate(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer)
	if (nstoppingfoillayers_idf(i).gt.0) then
      sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%n=nstoppingfoillayers_idf(i)
	allocate(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(nstoppingfoillayers_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer'
	  goto 1000
	end if
	end if
      do j=1,nstoppingfoillayers_idf(i)
c     layerelement
      sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%n=0
      if (allocated(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%layerelement)) 
     +deallocate(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%layerelement)
	if (nstoppingfoilels_idf(i,j).gt.0) then
      sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%n=nstoppingfoilels_idf(i,j)
	allocate(
     +sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%layerelement(nstoppingfoilels_idf(i,j)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%layerelement)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer%layerelements%layerelement'
	  goto 1000
	end if
	end if
	sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerthickness=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layeruniformity=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerdensity=idf_realquantity_null
	end do
	end do

c     detection - detector

c     detectortype
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%detection%detector%detectortype=' '
      sample%spectra%spectrum(i)%detection%detector%solidangle=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%detector%detectorshape=idf_shape_aux
      end do
c     detector - deadlayer
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%detection%detector%deadlayer%layerthickness=idf_realquantity_null
      sample%spectra%spectrum(i)%detection%detector%deadlayer%layeruniformity=idf_realquantity_null
      sample%spectra%spectrum(i)%detection%detector%deadlayer%layerdensity=idf_realquantity_null
      if (allocated(sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%layerelement)) 
     +deallocate(sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%layerelement)
      sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%n=0
      if (ndeadlayer_idf(i).gt.0) then
      sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%n=ndeadlayerels_idf(i)
      allocate(sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%layerelement(ndeadlayerels_idf(i)))
      end if
      end do
c     detector - entrancewindow
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%detection%detector%entrancewindow%n=0
      if (allocated(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer))
     +deallocate(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer)
	if (nentrancewindow_idf(i).gt.0) then
      sample%spectra%spectrum(i)%detection%detector%entrancewindow%n=nentrancewindow_idf(i)
	allocate(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(nentrancewindow_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer'
	  goto 1000
	end if
	end if
      do j=1,nentrancewindow_idf(i)
c     layerelement
      sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%n=0
      if (allocated(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%layerelement)) 
     +deallocate(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%layerelement)
	if (nentrancewindowels_idf(i,j).gt.0) then
      sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%n=nentrancewindowels_idf(i,j)
	allocate(
     +sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%layerelement(nentrancewindowels_idf(i,j)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%layerelement)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%detector%entrancewindow%layerelements%layerelement'
	  goto 1000
	end if
	end if
	sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerthickness=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layeruniformity=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerdensity=idf_realquantity_null
	end do
	end do
c     detector - detectorlayers
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%detection%detector%detectorlayers%n=0
      if (allocated(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer))
     +deallocate(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer)
	if (ndetectorlayers_idf(i).gt.0) then
      sample%spectra%spectrum(i)%detection%detector%detectorlayers%n=ndetectorlayers_idf(i)
	allocate(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(ndetectorlayers_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer'
	  goto 1000
	end if
	end if
      do j=1,ndetectorlayers_idf(i)
      sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%n=0
c     layerelement
      if (allocated(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%layerelement)) 
     +deallocate(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%layerelement)
	if (ndetectorlayersels_idf(i,j).gt.0) then
      sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%n=ndetectorlayersels_idf(i,j)
	allocate(
     +sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%layerelement(ndetectorlayersels_idf(i,j)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%layerelement)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%detector%detectorlayers%layerelements%layerelement'
	  goto 1000
	end if
	end if
	sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerthickness=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layeruniformity=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerdensity=idf_realquantity_null
	end do
	end do

c     tof
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%detection%detector%tof%toflength=idf_realquantity_null
      sample%spectra%spectrum(i)%detection%detector%tof%toftimeresolution=idf_realquantity_null
      end do
c     tof - startfoil
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%detection%detector%tof%startfoil%n=0
      if (allocated(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer))
     +deallocate(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer)
	if (ntofstartfoil_idf(i).gt.0) then
      sample%spectra%spectrum(i)%detection%detector%tof%startfoil%n=ntofstartfoil_idf(i)
	allocate(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(ntofstartfoil_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer'
	  goto 1000
	end if
	end if
      do j=1,ntofstartfoil_idf(i)
	sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%n=0
c     layerelement
      if (allocated(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%layerelement)) 
     +deallocate(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%layerelement)
	if (ntofstartfoilels_idf(i,j).gt.0) then
	sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%n=ntofstartfoilels_idf(i,j)
	allocate(
     +sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%layerelement(ntofstartfoilels_idf(i,j)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%layerelement)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layerelements%layerelement'
	  goto 1000
	end if
	end if
	sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerthickness=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layeruniformity=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerdensity=idf_realquantity_null
	end do
	end do
c     tof - stopfoil
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%n=0
      if (allocated(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer))
     +deallocate(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer)
	if (ntofstopfoil_idf(i).gt.0) then
      sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%n=ntofstopfoil_idf(i)
	allocate(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(ntofstopfoil_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer'
	  goto 1000
	end if
	end if
      do j=1,ntofstopfoil_idf(i)
      sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%n=0
c     layerelement
      if (allocated(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%layerelement)) 
     +deallocate(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%layerelement)
	if (ntofstopfoilels_idf(i,j).gt.0) then
	sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%n=ntofstopfoilels_idf(i,j)
	allocate(
     +sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%layerelement(ntofstopfoilels_idf(i,j)))
	if (.not.allocated(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%layerelement)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layerelements%layerelement'
	  goto 1000
	end if
	end if
	sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerthickness=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layeruniformity=idf_realquantity_null
	sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerdensity=idf_realquantity_null
	end do
	end do

c     spectrum - electronics
      do i=1,idfnspectra
        sample%spectra%spectrum(i)%detection%electronics%amplifier%amplifiertype=' '
        sample%spectra%spectrum(i)%detection%electronics%amplifier%pulseshape=' '
        sample%spectra%spectrum(i)%detection%electronics%amplifier%pur=' '
        sample%spectra%spectrum(i)%detection%electronics%amplifier%shapingtime=idf_realquantity_null
        sample%spectra%spectrum(i)%detection%electronics%amplifier%risetime=idf_realquantity_null
        sample%spectra%spectrum(i)%detection%electronics%amplifier%flattoptime=idf_realquantity_null
        sample%spectra%spectrum(i)%detection%electronics%amplifier%purtime=idf_realquantity_null
      end do

c     spectrum - calibrations - detectorefficiencies
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%calibrations%detectorefficiencies%n=0
      if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency))
     +deallocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency)
      if (ndetectorefficiency_idf(i).gt.0) then
      sample%spectra%spectrum(i)%calibrations%detectorefficiencies%n=ndetectorefficiency_idf(i)
      allocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(ndetectorefficiency_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency'
	  goto 1000
	end if
      do j=1,ndetectorefficiency_idf(i)
      sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%n=0
      sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n=0
      sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencyion=' '
      sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencymode=' '
c     for energy/efficiency
      if (trim(adjustl(efficiencymode_idf(i,j))).eq.'energy') then
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%n=
     +  ndetectorefficiencyentries_idf(i,j)
        if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%x))
     +  deallocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%x)
        allocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%
     +  x(ndetectorefficiencyentries_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%x)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency%efficiency%x'
	    goto 1000
	  end if
        if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%xerror))
     +  deallocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%xerror)
        allocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%
     +  xerror(ndetectorefficiencyentries_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%xerror)) then
	    idf_error=
     +    'problem allocating sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency%efficiency%xerror'
	    goto 1000
	  end if
        if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%y))
     +  deallocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%y)
        allocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%
     +  y(ndetectorefficiencyentries_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%y)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency%efficiency%y'
	    goto 1000
	  end if
        if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%yerror))
     +  deallocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%yerror)
        allocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%
     +  yerror(ndetectorefficiencyentries_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%yerror)) then
	    idf_error=
     +    'problem allocating sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency%efficiency%yerror'
	    goto 1000
	  end if
	  sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%x=0.
	  sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%xerror=0.
	  sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%y=0.
	  sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%yerror=0.
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%xaxis%axisname=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%xaxis%axisunit=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%xerroraxis%axisname=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%xerroraxis%axisunit=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%yaxis%axisname=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%yaxis%axisunit=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%yerroraxis%axisname=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%yerroraxis%axisunit=' '
c     for line/efficiency
      else if (trim(adjustl(efficiencymode_idf(i,j))).eq.'line') then
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n=
     +  ndetectorefficiencyentries_idf(i,j)
        if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%line))
     +  deallocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%line)
        allocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%
     +  line(ndetectorefficiencyentries_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%line)) then
	    idf_error=
     +    'problem allocating sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency%lineefficiency%line'
	    goto 1000
	  end if
        if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%y))
     +  deallocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%y)
        allocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%
     +  y(ndetectorefficiencyentries_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%y)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency%lineefficiency%y'
	    goto 1000
	  end if
        if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%yerror))
     +  deallocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%yerror)
        allocate(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%
     +  yerror(ndetectorefficiencyentries_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%yerror))
     +  then
	    idf_error=
     +    'problem allocating sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency%lineefficiency%yerror'
	    goto 1000
	  end if
	  sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%line=' '
	  sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%y=0.
	  sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%yerror=0.
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%xaxis%axisname=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%xaxis%axisunit=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%yaxis%axisname=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%yaxis%axisunit=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%yerroraxis%axisname=' '
        sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%yerroraxis%axisunit=' '
      end if
      end do
      end if
      end do

c     spectrum - calibrations - detectorresolutions
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%calibrations%detectorresolutions%n=0
      if (allocated(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution))
     +deallocate(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution)
      if (ndetectorresolution_idf(i).gt.0) then
      sample%spectra%spectrum(i)%calibrations%detectorresolutions%n=ndetectorresolution_idf(i)
      allocate(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(ndetectorresolution_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution'
	  goto 1000
	end if
      do j=1,ndetectorresolution_idf(i)
      sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%resolutionparameters%n=0
      sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%resolutionion=' '
      if (allocated(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter))
     +deallocate(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter)
      if (nresolutionparameter_idf(i,j).gt.0) then
      sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%resolutionparameters%n=
     +nresolutionparameter_idf(i,j)
      allocate(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter(nresolutionparameter_idf(i,j)))
	if (.not.allocated(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter'
	  goto 1000
	end if
	sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter=idf_realquantity_null
	end if
	end do
	end if
	end do

c     spectrum - calibrations - energycalibrations
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%calibrations%energycalibrations%n=0
      if (allocated(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration))
     +deallocate(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration)
      if (nenergycalibration_idf(i).gt.0) then
      sample%spectra%spectrum(i)%calibrations%energycalibrations%n=nenergycalibration_idf(i)
      allocate(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(nenergycalibration_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration'
	  goto 1000
	end if
      do j=1,nenergycalibration_idf(i)
      sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationparameters%n=0
      sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationion=' '
      sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationmode=' '
      if (allocated(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter))
     +deallocate(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter)
      if (ncalibrationparameter_idf(i,j).gt.0) then
      sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationparameters%n
     +=ncalibrationparameter_idf(i,j)
      allocate(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter(ncalibrationparameter_idf(i,j)))
	if (.not.allocated(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter'
	  goto 1000
	end if
	sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter=idf_realquantity_null
	end if
	end do
	end if
	end do

c     spectrum - reations
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%reactions%reactionlist%n=0
	sample%spectra%spectrum(i)%reactions%technique=' '
      if (allocated(sample%spectra%spectrum(i)%reactions%reactionlist%reaction))
     +deallocate(sample%spectra%spectrum(i)%reactions%reactionlist%reaction)
      if (nreaction_idf(i).gt.0) then
      sample%spectra%spectrum(i)%reactions%reactionlist%n=nreaction_idf(i)
      allocate(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(nreaction_idf(i)))
	if (.not.allocated(sample%spectra%spectrum(i)%reactions%reactionlist%reaction)) then
	  idf_error='problem allocating sample%spectra%spectrum(i)%reactions%reactionlist%reaction'
	  goto 1000
	end if
c     these are all arrays
	sample%spectra%spectrum(i)%reactions%reactionlist%reaction%initialtargetparticle=' '
	sample%spectra%spectrum(i)%reactions%reactionlist%reaction%incidentparticle=' '
	sample%spectra%spectrum(i)%reactions%reactionlist%reaction%exitparticle=' '
	sample%spectra%spectrum(i)%reactions%reactionlist%reaction%finaltargetparticle=' '
	sample%spectra%spectrum(i)%reactions%reactionlist%reaction%reactionQ=idf_realquantity_null
	end if
	end do

c     spectrum - data
      do i=1,idfnspectra
      sample%spectra%spectrum(i)%data%simpledata%n=0
      sample%spectra%spectrum(i)%data%linedata%n=0
      sample%spectra%spectrum(i)%data%complexdata%dataentries%n=0
      sample%spectra%spectrum(i)%data%datamode=' '
      sample%spectra%spectrum(i)%data%channelmode=' '
c     for simple data
      if (trim(adjustl(datamode_idf(i))).eq.'simple') then
        if (allocated(sample%spectra%spectrum(i)%data%simpledata%x))
     +  deallocate(sample%spectra%spectrum(i)%data%simpledata%x)
        if (allocated(sample%spectra%spectrum(i)%data%simpledata%xerror))
     +  deallocate(sample%spectra%spectrum(i)%data%simpledata%xerror)
        if (allocated(sample%spectra%spectrum(i)%data%simpledata%y))
     +  deallocate(sample%spectra%spectrum(i)%data%simpledata%y)
        if (allocated(sample%spectra%spectrum(i)%data%simpledata%yerror))
     +  deallocate(sample%spectra%spectrum(i)%data%simpledata%yerror)
        if (ndatapoints_idf(i).gt.0) then
        sample%spectra%spectrum(i)%data%simpledata%n=ndatapoints_idf(i)
        allocate(sample%spectra%spectrum(i)%data%simpledata%x(ndatapoints_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%simpledata%x)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%simpledata%x'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%data%simpledata%xerror(ndatapoints_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%simpledata%xerror)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%simpledata%xerror'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%data%simpledata%y(ndatapoints_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%simpledata%y)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%simpledata%y'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%data%simpledata%yerror(ndatapoints_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%simpledata%yerror)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%simpledata%yerror'
	    goto 1000
	  end if
	  end if
	  sample%spectra%spectrum(i)%data%simpledata%x=0.
	  sample%spectra%spectrum(i)%data%simpledata%xerror=0.
	  sample%spectra%spectrum(i)%data%simpledata%y=0.
	  sample%spectra%spectrum(i)%data%simpledata%yerror=0.
        sample%spectra%spectrum(i)%data%simpledata%xaxis%axisname=' '
        sample%spectra%spectrum(i)%data%simpledata%xaxis%axisunit=' '
        sample%spectra%spectrum(i)%data%simpledata%xerroraxis%axisname=' '
        sample%spectra%spectrum(i)%data%simpledata%xerroraxis%axisunit=' '
        sample%spectra%spectrum(i)%data%simpledata%yaxis%axisname=' '
        sample%spectra%spectrum(i)%data%simpledata%yaxis%axisunit=' '
        sample%spectra%spectrum(i)%data%simpledata%yerroraxis%axisname=' '
        sample%spectra%spectrum(i)%data%simpledata%yerroraxis%axisunit=' '
c     for line data
      else if (trim(adjustl(datamode_idf(i))).eq.'line') then
        if (allocated(sample%spectra%spectrum(i)%data%linedata%line))
     +  deallocate(sample%spectra%spectrum(i)%data%linedata%line)
        if (allocated(sample%spectra%spectrum(i)%data%linedata%y))
     +  deallocate(sample%spectra%spectrum(i)%data%linedata%y)
        if (allocated(sample%spectra%spectrum(i)%data%linedata%yerror))
     +  deallocate(sample%spectra%spectrum(i)%data%linedata%yerror)
        if (ndatapoints_idf(i).gt.0) then
        sample%spectra%spectrum(i)%data%linedata%n=ndatapoints_idf(i)
        allocate(sample%spectra%spectrum(i)%data%linedata%line(ndatapoints_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%linedata%line)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%linedata%line'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%data%linedata%y(ndatapoints_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%linedata%y)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%linedata%y'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%data%linedata%yerror(ndatapoints_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%linedata%yerror)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%linedata%yerror'
	    goto 1000
	  end if
	  end if
	  sample%spectra%spectrum(i)%data%linedata%line=' '
	  sample%spectra%spectrum(i)%data%linedata%y=0.
	  sample%spectra%spectrum(i)%data%linedata%yerror=0.
        sample%spectra%spectrum(i)%data%linedata%xaxis%axisname=' '
        sample%spectra%spectrum(i)%data%linedata%xaxis%axisunit=' '
        sample%spectra%spectrum(i)%data%linedata%yaxis%axisname=' '
        sample%spectra%spectrum(i)%data%linedata%yaxis%axisunit=' '
        sample%spectra%spectrum(i)%data%linedata%yerroraxis%axisname=' '
        sample%spectra%spectrum(i)%data%linedata%yerroraxis%axisunit=' '
c     for complex data
      else if (trim(adjustl(datamode_idf(i))).eq.'complex') then
        if (allocated(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry))
     +  deallocate(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry)
c       allocate the xaxes
	  if (datadimensionx_idf(i).gt.0) then
        if (allocated(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis))
     +  deallocate(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis)
        allocate(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis(datadimensionx_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%complexdata%xaxes%axis'
	    goto 1000
	  end if
	  end if
c       allocate the yaxes
	  if (datadimensiony_idf(i).gt.0) then
        if (allocated(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis))
     +  deallocate(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis)
        allocate(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis(datadimensiony_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%complexdata%xaxes%axis'
	    goto 1000
	  end if
	  end if
        if (ndatapoints_idf(i).gt.0) then
        sample%spectra%spectrum(i)%data%complexdata%dataentries%n=ndatapoints_idf(i)
c       allocate the dataentry
        if (allocated(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry))
     +  deallocate(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry)
        allocate(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(ndatapoints_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry'
	    goto 1000
	  end if
c       allocate the dataitem
	  if (datadimensionx_idf(i)+datadimensiony_idf(i).gt.0) then
	  do j=1,ndatapoints_idf(i)
        if (allocated(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%dataitem))
     +  deallocate(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%dataitem)
        allocate(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%
     +  dataitem(datadimensionx_idf(i)+datadimensiony_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%dataitem)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%dataitem'
	    goto 1000
	  end if
	  end do
        end if
	  end if
c       initialise variables
  	  sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx=0
  	  sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony=0
  	  do j=1,datadimensionx_idf(i)
  	    sample%spectra%spectrum(i)%data%complexdata%xaxes%axis(j)%axisname=' '
  	    sample%spectra%spectrum(i)%data%complexdata%xaxes%axis(j)%axisunit=' '
  	  end do
  	  do j=1,datadimensiony_idf(i)
  	    sample%spectra%spectrum(i)%data%complexdata%yaxes%axis(j)%axisname=' '
  	    sample%spectra%spectrum(i)%data%complexdata%yaxes%axis(j)%axisunit=' '
  	  end do
  	  do j=1,ndatapoints_idf(i)
  	    sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%timestamp=' '
  	    sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%line=' '
  	    do k=1,datadimensionx_idf(i)+datadimensiony_idf(i)
  	      sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%dataitem(k)=0.
  	    end do
  	  end do
      else if (trim(adjustl(datamode_idf(i))).eq.'datafile') then
  	  sample%spectra%spectrum(i)%data%datafile%filename=' '
  	  sample%spectra%spectrum(i)%data%datafile%fileformat=' '
  	  sample%spectra%spectrum(i)%data%datafile%filesource=' '
      end if
      end do

c     here ended huge group data

c     here starts huge group process

c     here starts group process - physicsdefaults

c     process - physicsdefaults - crosssectiondefault
      do i=1,idfnspectra
        sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%Rutherford=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%screening=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%name=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%version=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%builddate=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%releasedate=' '
      end do
c     process - physicsdefaults - crosssectiondefault
      do i=1,idfnspectra
        sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%name=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%version=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%builddate=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%releasedate=' '
      end do
c     process - physicsdefaults - energyspreaddefault
      do i=1,idfnspectra
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%energylossstraggling=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%multiplescattering=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%Dopplereffect=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%beamangularspread=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%beamsize=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%detectoraperture=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%Tschalareffect=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%name=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%version=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%builddate=' '
        sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%releasedate=' '
      end do

c     process - simulation - physics
      do i=1,idfnspectra
        sample%spectra%spectrum(i)%process%simulations%n=0
        if (nsimulation_idf(i).gt.0) then
        sample%spectra%spectrum(i)%process%simulations%n=nsimulation_idf(i)
c       allocate the simulation
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation)
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(nsimulation_idf(i)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation'
	    goto 1000
	  end if

c       process - physics - crosssections
        do j=1,nsimulation_idf(i)
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%n=0
          if (ncrosssection_idf(i,j).gt.0) then
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%n=ncrosssection_idf(i,j)
c         allocate the crosssection
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    crosssections%crosssection(ncrosssection_idf(i,j)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection)) then
	      idf_error=
     +      'problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection'
	      goto 1000
	    end if
          end if
c         initialise variables - general
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%mode=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionframe=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiontype=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%energyminimum=
     +    idf_realquantity_null
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%energymaximum=
     +    idf_realquantity_null
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%reaction%
     +    initialtargetparticle=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%reaction%
     +    incidentparticle=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%reaction%
     +    exitparticle=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%reaction%
     +    finaltargetparticle=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%reaction%
     +    reactionQ=idf_realquantity_null
c         initialise variables - option 1
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionfile%
     +    filename=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionfile%
     +    fileformat=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionfile%
     +    filesource=' '
c         initialise variables - option 3
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionoverride%
     +    Rutherford=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionoverride%
     +    screening=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionoverride%
     +    computercode%name=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionoverride%
     +    computercode%version=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionoverride%
     +    computercode%builddate=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectionoverride%
     +    computercode%releasedate=' '
c         initialise variables - option 2
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%
     +    xaxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%
     +    xaxis%axisunit=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%
     +    xerroraxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%
     +    xerroraxis%axisunit=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%
     +    yaxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%
     +    yaxis%axisunit=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%
     +    yerroraxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%
     +    yerroraxis%axisunit=' '
c         allocate the data arrays
          do k=1,ncrosssection_idf(i,j)
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%n=0
          if (ncrosssectionpoints_idf(i,j,k).gt.0) then
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%n=ncrosssectionpoints_idf(i,j,k)
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%x))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%x)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%x(ncrosssectionpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%x)) then
	      idf_error=
     +     'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%x'
	      goto 1000
	    end if
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%xerror))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%xerror)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%xerror(ncrosssectionpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%xerror)) then
	      idf_error=
     +     'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%xerror'
	      goto 1000
	    end if
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%y))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%y)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%y(ncrosssectionpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%y)) then
	      idf_error=
     +     'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%y'
	      goto 1000
	    end if
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%yerror))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%yerror)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%yerror(ncrosssectionpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%yerror)) then
	      idf_error=
     +     'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection%crosssectiondata%yerror'
	      goto 1000
	    end if
	    end if
	    end do
c       end of cycle process - physics - crosssections
        end do

c       process - physics - stoppingpowers
        do j=1,nsimulation_idf(i)
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%n=0
          if (nstoppingpower_idf(i,j).gt.0) then
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%n=nstoppingpower_idf(i,j)
c         allocate the stoppingpower
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf(i,j)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower)) then
	      idf_error=
     +      'problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower'
	      goto 1000
	    end if
          end if
c         initialise variables - general
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%mode=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%ion=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%ionchargestate=
     +    idf_realquantity_null
c         target element or molecule - option 1
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%targetelement=' '
c         target element or molecule - option 2
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%targetmolecule=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingmode=' '
c         initialise variables - option 1
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerfile%
     +    filename=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerfile%
     +    fileformat=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerfile%
     +    filesource=' '
c         initialise variables - option 3
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpoweroverride%
     +    computercode%name=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpoweroverride%
     +    computercode%version=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpoweroverride%
     +    computercode%builddate=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpoweroverride%
     +    computercode%releasedate=' '
c         initialise variables - option 2
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%
     +    xaxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%
     +    xaxis%axisunit=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%
     +    xerroraxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%
     +    xerroraxis%axisunit=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%
     +    yaxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%
     +    yaxis%axisunit=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%
     +    yerroraxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%
     +    yerroraxis%axisunit=' '
c         allocate the data arrays
          do k=1,nstoppingpower_idf(i,j)
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    stoppingpowers%stoppingpower(k)%stoppingpowerdata%n=0
          if (nstoppingpowerpoints_idf(i,j,k).gt.0) then
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    stoppingpowers%stoppingpower(k)%stoppingpowerdata%n=nstoppingpowerpoints_idf(i,j,k)
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%x))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%x)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%x(nstoppingpowerpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%x)) then
	      idf_error=
     +     'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%x'
	      goto 1000
	    end if
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%xerror))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%xerror)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%xerror(nstoppingpowerpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%xerror)) then
	      idf_error=
     +  'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%xerror'
	      goto 1000
	    end if
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%y))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%y)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%y(nstoppingpowerpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%y)) then
	      idf_error=
     +     'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%y'
	      goto 1000
	    end if
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%yerror))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%yerror)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%yerror(nstoppingpowerpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +    stoppingpowerdata%yerror)) then
	      idf_error=
     +  'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower%stoppingpowerdata%yerror'
	      goto 1000
	    end if
	    end if
	    end do
c       end of cycle process - physics - stoppingpowers
        end do

c       process - physics - energyspreads
        do j=1,nsimulation_idf(i)
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%n=0
          if (nenergyspread_idf(i,j).gt.0) then
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%n=nenergyspread_idf(i,j)
c         allocate the energyspread
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    energyspreads%energyspread(nenergyspread_idf(i,j)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread)) then
	      idf_error=
     +      'problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread'
	      goto 1000
	    end if
          end if
c         initialise variables - general
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%mode=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%ion=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%ionchargestate=
     +    idf_realquantity_null
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%targetelement=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadmode=' '
c         initialise variables - option 1
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadfile%
     +    filename=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadfile%
     +    fileformat=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadfile%
     +    filesource=' '
c         initialise variables - option 3
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    energylossstraggling=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    multiplescattering=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    Dopplereffect=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    beamangularspread=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    geometricspread%beamsize=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    geometricspread%detectoraperture=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    Tschalareffect=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    computercode%name=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    computercode%version=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    computercode%builddate=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreadoverride%
     +    computercode%releasedate=' '
c         initialise variables - option 2
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%
     +    xaxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%
     +    xaxis%axisunit=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%
     +    xerroraxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%
     +    xerroraxis%axisunit=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%
     +    yaxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%
     +    yaxis%axisunit=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%
     +    yerroraxis%axisname=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%
     +    yerroraxis%axisunit=' '
c         allocate the data arrays
          do k=1,nenergyspread_idf(i,j)
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    energyspreads%energyspread(k)%energyspreaddata%n=0
          if (nenergyspreadpoints_idf(i,j,k).gt.0) then
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    energyspreads%energyspread(k)%energyspreaddata%n=nenergyspreadpoints_idf(i,j,k)
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%x))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%x)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%x(nenergyspreadpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%x)) then
	      idf_error=
     +     'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%x'
	      goto 1000
	    end if
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%xerror))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%xerror)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%xerror(nenergyspreadpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%xerror)) then
	      idf_error=
     +  'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%xerror'
	      goto 1000
	    end if
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%y))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%y)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%y(nenergyspreadpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%y)) then
	      idf_error=
     +     'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%y'
	      goto 1000
	    end if
          if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%yerror))
     +    deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%yerror)
          allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%yerror(nenergyspreadpoints_idf(i,j,k)))
	    if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +    energyspreaddata%yerror)) then
	      idf_error=
     +  'sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread%energyspreaddata%yerror'
	      goto 1000
	    end if
	    end if
	    end do
c       end of cycle process - physics - energyspreads
        end do

c       process - simulationtype etc
        do j=1,nsimulation_idf(i)
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%simulationtype=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%initialtargetparticle=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%initialtargetparticle=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%incidentparticle=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%exitparticle=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%finaltargetparticle=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%targetlayer=0
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode=' '
          sample%spectra%spectrum(i)%process%simulations%simulation(j)%channelmode=' '
        end do

        end if
      end do

c     process - simulation
      do i=1,idfnspectra
        if (nsimulation_idf(i).gt.0) then
c       process - physics - crosssections
        do j=1,nsimulation_idf(i)

      sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode=' '
      sample%spectra%spectrum(i)%process%simulations%simulation(j)%channelmode=' '
c     for simple data
      if (trim(adjustl(simmode_idf(i,j))).eq.'simple') then
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%n=0
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x)
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror)
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y)
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror)
c      write(*,*)'nsimpoints_idf(i,j) ',i,nsimpoints_idf(i,j)
        if (nsimpoints_idf(i,j).gt.0) then
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%n=nsimpoints_idf(i,j)
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x(nsimpoints_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror(nsimpoints_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y(nsimpoints_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror(nsimpoints_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror'
	    goto 1000
	  end if
	  end if
	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x=0.
	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror=0.
	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y=0.
	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror=0.
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xaxis%axisname=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xaxis%axisunit=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerroraxis%axisname=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerroraxis%axisunit=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yaxis%axisname=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yaxis%axisunit=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerroraxis%axisname=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerroraxis%axisunit=' '
c     for line data
      else if (trim(adjustl(simmode_idf(i,j))).eq.'line') then
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%n=0
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%line))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%line)
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y)
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror)
        if (nsimpoints_idf(i,j).gt.0) then
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%n=nsimpoints_idf(i,j)
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%line(nsimpoints_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%line)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%line'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y(nsimpoints_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y'
	    goto 1000
	  end if
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror(nsimpoints_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror'
	    goto 1000
	  end if
	  end if
	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%line=' '
	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y=0.
	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror=0.
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%xaxis%axisname=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%xaxis%axisunit=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yaxis%axisname=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yaxis%axisunit=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerroraxis%axisname=' '
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerroraxis%axisunit=' '
c     for complex data
      else if (trim(adjustl(simmode_idf(i,j))).eq.'complex') then
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%n=0
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx=0
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony=0
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry)
c       allocate the xaxes
	  if (simdimensionx_idf(i,j).gt.0) then
	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx=
     +  simdimensionx_idf(i,j)
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis)
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis(simdimensionx_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis'
	    goto 1000
	  end if
	  end if
c       allocate the yaxes
	  if (simdimensiony_idf(i,j).gt.0) then
	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony=
     +  simdimensiony_idf(i,j)
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis)
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis(simdimensiony_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis'
	    goto 1000
	  end if
	  end if
        if (nsimpoints_idf(i,j).gt.0) then
        sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%n=nsimpoints_idf(i,j)
c       allocate the dataentry
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%
     +  dataentry(nsimpoints_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry)) then
	    idf_error='problem allocating sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry'
	    goto 1000
	  end if
c       allocate the dataitem
	  if (simdimensionx_idf(i,j)+simdimensiony_idf(i,j).gt.0) then
	  do k=1,nsimpoints_idf(i,j)
        if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry(k)%dataitem))
     +  deallocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry(k)%dataitem)
        allocate(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry(k)%
     +  dataitem(simdimensionx_idf(i,j)+simdimensiony_idf(i,j)))
	  if (.not.allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%
     +  dataentry(k)%dataitem)) then
	    idf_error=
     +    'problem allocating sample%spectra%spectrum(i)%process%simulations%simulation%complexdata%dataentries%dataentry%dataitem'
	    goto 1000
	  end if
	  end do
        end if
	  end if
c       initialise variables
  	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx=0
  	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony=0
  	  do k=1,simdimensionx_idf(i,j)
  	    sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis(k)%axisname=' '
  	    sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis(k)%axisunit=' '
  	  end do
  	  do k=1,simdimensiony_idf(i,j)
  	    sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis(k)%axisname=' '
  	    sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis(k)%axisunit=' '
  	  end do
  	  do k=1,nsimpoints_idf(i,j)
  	    sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry(k)%timestamp=' '
  	    sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry(k)%line=' '
  	    do k1=1,simdimensionx_idf(i,j)+simdimensiony_idf(i,j)
  	      sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry(k)%dataitem(k1)=0.
  	    end do
  	  end do
      else if (trim(adjustl(simmode_idf(i,j))).eq.'datafile') then
  	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%datafile%filename=' '
  	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%datafile%fileformat=' '
  	  sample%spectra%spectrum(i)%process%simulations%simulation(j)%datafile%filesource=' '
      end if

        end do
        end if
c     end of cycle process - simulation
      end do

      idf_ok=.true.
1001  continue
	return
1000  continue
	return
	end

c-----------------------------------------------------------------------
	subroutine deallocate_idf_tags
      !DEC$ ATTRIBUTES DLLEXPORT::deallocate_idf_tags
c     routine that deallocates all the required variables for one single sample from file idf_file. This is IDF tags only
	use IDFCOM
	implicit none
	integer i,j,k,k1
c-----------------------------------------------------------------------
      idf_ok=.false.
      idf_error=' '

c     pointbypointstructure - pbp_aux
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%x)
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%xerror)
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%y)
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%yerror)

c     elementsandmolecules
	if (allocated(sample%elementsandmolecules%elements%element)) deallocate(sample%elementsandmolecules%elements%element)
	if (allocated(sample%elementsandmolecules%molecules%molecule)) deallocate(sample%elementsandmolecules%molecules%molecule)

c     structure - layeredstructure - layer
      if (allocated(sample%structure%layeredstructure%layers%layer)) deallocate(sample%structure%layeredstructure%layers%layer)

c     pointbypointstructure - element
      if (allocated(sample%structure%pointbypointstructure%pbpelement))deallocate(sample%structure%pointbypointstructure%pbpelement)

c     spectrum
      if (allocated(sample%spectra%spectrum)) deallocate(sample%spectra%spectrum)

      idf_ok=.true.
	return
	end

c-----------------------------------------------------------------------
	subroutine allocate_secondary_variables_idf
      !DEC$ ATTRIBUTES DLLEXPORT::allocate_secondary_variables_idf
c     allocates some basic variables, that mostly control the dimentions of the problem
	use IDFCOM
	implicit none
c-----------------------------------------------------------------------
      if (allocated(nbeamfoillayers_idf)) deallocate(nbeamfoillayers_idf)
      allocate(nbeamfoillayers_idf(idfnspectra))
      nbeamfoillayers_idf=0
      if (allocated(nstoppingfoillayers_idf)) deallocate(nstoppingfoillayers_idf)
      allocate(nstoppingfoillayers_idf(idfnspectra))
      nstoppingfoillayers_idf=0
      if (allocated(nbeamchargestate_idf)) deallocate(nbeamchargestate_idf)
      allocate(nbeamchargestate_idf(idfnspectra))
      nbeamchargestate_idf=0
      if (allocated(nbeamfoilels_idf)) deallocate(nbeamfoilels_idf)
      allocate(nbeamfoilels_idf(idfnspectra,idfnfoillayers))
      nbeamfoilels_idf=0
      if (allocated(nstoppingfoilels_idf)) deallocate(nstoppingfoilels_idf)
      allocate(nstoppingfoilels_idf(idfnspectra,idfnfoillayers))
      nstoppingfoilels_idf=0
      if (allocated(npbp_idf)) deallocate(npbp_idf)
      allocate(npbp_idf(idfnspectra))
      npbp_idf=0
      if (allocated(nlayerspbp_idf)) deallocate(nlayerspbp_idf)
      allocate(nlayerspbp_idf(idfnspectra,idfnelements))
      nlayerspbp_idf=0
      if (allocated(nslitsaftersample_idf)) deallocate(nslitsaftersample_idf)
      allocate(nslitsaftersample_idf(idfnspectra))
      nslitsaftersample_idf=0
      if (allocated(nslitsbeforesample_idf)) deallocate(nslitsbeforesample_idf)
      allocate(nslitsbeforesample_idf(idfnspectra))
      nslitsbeforesample_idf=0
      if (allocated(ndeadlayer_idf)) deallocate(ndeadlayer_idf)
      allocate(ndeadlayer_idf(idfnspectra))
      ndeadlayer_idf=0
      if (allocated(ndeadlayerels_idf)) deallocate(ndeadlayerels_idf)
      allocate(ndeadlayerels_idf(idfnspectra))
      ndeadlayerels_idf=0
      if (allocated(nentrancewindow_idf)) deallocate(nentrancewindow_idf)
      allocate(nentrancewindow_idf(idfnspectra))
      nentrancewindow_idf=0
      if (allocated(nentrancewindowels_idf)) deallocate(nentrancewindowels_idf)
      allocate(nentrancewindowels_idf(idfnspectra,idfnfoillayers))
      nentrancewindowels_idf=0
      if (allocated(ndetectorlayers_idf)) deallocate(ndetectorlayers_idf)
      allocate(ndetectorlayers_idf(idfnspectra))
      ndetectorlayers_idf=0
      if (allocated(ndetectorlayersels_idf)) deallocate(ndetectorlayersels_idf)
      allocate(ndetectorlayersels_idf(idfnspectra,idfnfoillayers))
      ndetectorlayersels_idf=0
      if (allocated(ntofstartfoil_idf)) deallocate(ntofstartfoil_idf)
      allocate(ntofstartfoil_idf(idfnspectra))
      ntofstartfoil_idf=0
      if (allocated(ntofstartfoilels_idf)) deallocate(ntofstartfoilels_idf)
      allocate(ntofstartfoilels_idf(idfnspectra,idfnfoillayers))
      ntofstartfoilels_idf=0
      if (allocated(ntofstopfoil_idf)) deallocate(ntofstopfoil_idf)
      allocate(ntofstopfoil_idf(idfnspectra))
      ntofstopfoil_idf=0
      if (allocated(ntofstopfoilels_idf)) deallocate(ntofstopfoilels_idf)
      allocate(ntofstopfoilels_idf(idfnspectra,idfnfoillayers))
      ntofstopfoilels_idf=0
      if (allocated(ndetectorefficiency_idf)) deallocate(ndetectorefficiency_idf)
      allocate(ndetectorefficiency_idf(idfnspectra))
      ndetectorefficiency_idf=0
      if (allocated(ndetectorefficiencyentries_idf)) deallocate(ndetectorefficiencyentries_idf)
      allocate(ndetectorefficiencyentries_idf(idfnspectra,idfndetectorefficiency))
      ndetectorefficiencyentries_idf=0
      if (allocated(efficiencymode_idf)) deallocate(efficiencymode_idf)
      allocate(efficiencymode_idf(idfnspectra,idfndetectorefficiency))
      efficiencymode_idf=' '
      if (allocated(ndetectorresolution_idf)) deallocate(ndetectorresolution_idf)
      allocate(ndetectorresolution_idf(idfnspectra))
      ndetectorresolution_idf=0
      if (allocated(nresolutionparameter_idf)) deallocate(nresolutionparameter_idf)
      allocate(nresolutionparameter_idf(idfnspectra,idfnelements))
      nresolutionparameter_idf=0
      if (allocated(nenergycalibration_idf)) deallocate(nenergycalibration_idf)
      allocate(nenergycalibration_idf(idfnspectra))
      nenergycalibration_idf=0
      if (allocated(ncalibrationparameter_idf)) deallocate(ncalibrationparameter_idf)
      allocate(ncalibrationparameter_idf(idfnspectra,idfnelements))
      ncalibrationparameter_idf=0
      if (allocated(nreaction_idf)) deallocate(nreaction_idf)
      allocate(nreaction_idf(idfnspectra))
      nreaction_idf=0
      if (allocated(ndatapoints_idf)) deallocate(ndatapoints_idf)
      allocate(ndatapoints_idf(idfnspectra))
      ndatapoints_idf=0
      if (allocated(ndatatimestamp_idf)) deallocate(ndatatimestamp_idf)
      allocate(ndatatimestamp_idf(idfnspectra))
      ndatatimestamp_idf=0
      if (allocated(ndataline_idf)) deallocate(ndataline_idf)
      allocate(ndataline_idf(idfnspectra))
      ndataline_idf=0
      if (allocated(datadimensionx_idf)) deallocate(datadimensionx_idf)
      allocate(datadimensionx_idf(idfnspectra))
      datadimensionx_idf=0
      if (allocated(datadimensiony_idf)) deallocate(datadimensiony_idf)
      allocate(datadimensiony_idf(idfnspectra))
      datadimensiony_idf=0
      if (allocated(datamode_idf)) deallocate(datamode_idf)
      allocate(datamode_idf(idfnspectra))
      datamode_idf=' '
      if (allocated(nsimulation_idf)) deallocate(nsimulation_idf)
      allocate(nsimulation_idf(idfnspectra))
      nsimulation_idf=0
      if (allocated(ncrosssection_idf)) deallocate(ncrosssection_idf)
      allocate(ncrosssection_idf(idfnspectra,idfnelements+1))
      ncrosssection_idf=0
      if (allocated(ncrosssectionpoints_idf)) deallocate(ncrosssectionpoints_idf)
      allocate(ncrosssectionpoints_idf(idfnspectra,idfnelements+1,idfnelements))
      ncrosssectionpoints_idf=0
      if (allocated(nstoppingpower_idf)) deallocate(nstoppingpower_idf)
      allocate(nstoppingpower_idf(idfnspectra,max(idfnelements,idfnmolecules)+1))
      nstoppingpower_idf=0
      if (allocated(nstoppingpowerpoints_idf)) deallocate(nstoppingpowerpoints_idf)
      allocate
     +(nstoppingpowerpoints_idf(idfnspectra,max(idfnelements,idfnmolecules)+1,max(idfnelements,idfnmolecules)))
      nstoppingpowerpoints_idf=0
      if (allocated(nenergyspread_idf)) deallocate(nenergyspread_idf)
      allocate(nenergyspread_idf(idfnspectra,max(idfnelements,idfnmolecules)+1))
      nenergyspread_idf=0
      if (allocated(nenergyspreadpoints_idf)) deallocate(nenergyspreadpoints_idf)
      allocate
     +(nenergyspreadpoints_idf(idfnspectra,max(idfnelements,idfnmolecules)+1,max(idfnelements,idfnmolecules)))
      nenergyspreadpoints_idf=0
      if (allocated(simmode_idf)) deallocate(simmode_idf)
      allocate(simmode_idf(idfnspectra,idfnelements+1))
      datamode_idf=' '
c      if (allocated(nsimulation_idf)) deallocate(nsimulation_idf)
c      allocate(nsimulation_idf(idfnspectra))
c      nsimulation_idf=' '
      if (allocated(simdimensionx_idf)) deallocate(simdimensionx_idf)
      allocate(simdimensionx_idf(idfnspectra,idfnelements+1))
      simdimensionx_idf=0
      if (allocated(simdimensiony_idf)) deallocate(simdimensiony_idf)
      allocate(simdimensiony_idf(idfnspectra,idfnelements+1))
      simdimensiony_idf=0
      if (allocated(nsimpoints_idf)) deallocate(nsimpoints_idf)
      allocate(nsimpoints_idf(idfnspectra,idfnelements+1))
      nsimpoints_idf=0

      idf_ok=.true.
1001  continue
	return
1000  continue
      idf_error='error allocating basic variables'
	return
	end

c-----------------------------------------------------------------------
	subroutine deallocate_auxiliary_variables_idf
      !DEC$ ATTRIBUTES DLLEXPORT::deallocate_auxiliary_variables_idf
c     deallocates some basic variables, that mostly control the dimentions of the problem
	use IDFCOM
	implicit none
c-----------------------------------------------------------------------
      if (allocated(nbeamfoillayers_idf)) deallocate(nbeamfoillayers_idf)
      if (allocated(nstoppingfoillayers_idf)) deallocate(nstoppingfoillayers_idf)
      if (allocated(nbeamchargestate_idf)) deallocate(nbeamchargestate_idf)
      if (allocated(nbeamfoilels_idf)) deallocate(nbeamfoilels_idf)
      if (allocated(nstoppingfoilels_idf)) deallocate(nstoppingfoilels_idf)
      if (allocated(npbp_idf)) deallocate(npbp_idf)
      if (allocated(nlayerspbp_idf)) deallocate(nlayerspbp_idf)
      if (allocated(nslitsaftersample_idf)) deallocate(nslitsaftersample_idf)
      if (allocated(nslitsbeforesample_idf)) deallocate(nslitsbeforesample_idf)
      if (allocated(ndeadlayer_idf)) deallocate(ndeadlayer_idf)
      if (allocated(ndeadlayerels_idf)) deallocate(ndeadlayerels_idf)
      if (allocated(nentrancewindow_idf)) deallocate(nentrancewindow_idf)
      if (allocated(nentrancewindowels_idf)) deallocate(nentrancewindowels_idf)
      if (allocated(ndetectorlayers_idf)) deallocate(ndetectorlayers_idf)
      if (allocated(ndetectorlayersels_idf)) deallocate(ndetectorlayersels_idf)
      if (allocated(ntofstartfoil_idf)) deallocate(ntofstartfoil_idf)
      if (allocated(ntofstartfoilels_idf)) deallocate(ntofstartfoilels_idf)
      if (allocated(ntofstopfoil_idf)) deallocate(ntofstopfoil_idf)
      if (allocated(ntofstopfoilels_idf)) deallocate(ntofstopfoilels_idf)
      if (allocated(ndetectorefficiency_idf)) deallocate(ndetectorefficiency_idf)
      if (allocated(ndetectorefficiencyentries_idf)) deallocate(ndetectorefficiencyentries_idf)
      if (allocated(efficiencymode_idf)) deallocate(efficiencymode_idf)
      if (allocated(ndetectorresolution_idf)) deallocate(ndetectorresolution_idf)
      if (allocated(nresolutionparameter_idf)) deallocate(nresolutionparameter_idf)
      if (allocated(nenergycalibration_idf)) deallocate(nenergycalibration_idf)
      if (allocated(ncalibrationparameter_idf)) deallocate(ncalibrationparameter_idf)
      if (allocated(nreaction_idf)) deallocate(nreaction_idf)
      if (allocated(ndatapoints_idf)) deallocate(ndatapoints_idf)
      if (allocated(ndatatimestamp_idf)) deallocate(ndatatimestamp_idf)
      if (allocated(ndataline_idf)) deallocate(ndataline_idf)
      if (allocated(datadimensionx_idf)) deallocate(datadimensionx_idf)
      if (allocated(datadimensiony_idf)) deallocate(datadimensiony_idf)
      if (allocated(datamode_idf)) deallocate(datamode_idf)
      if (allocated(nsimulation_idf)) deallocate(nsimulation_idf)
      if (allocated(ncrosssection_idf)) deallocate(ncrosssection_idf)
      if (allocated(ncrosssectionpoints_idf)) deallocate(ncrosssectionpoints_idf)
      if (allocated(nstoppingpower_idf)) deallocate(nstoppingpower_idf)
      if (allocated(nstoppingpowerpoints_idf)) deallocate(nstoppingpowerpoints_idf)
      if (allocated(nenergyspread_idf)) deallocate(nenergyspread_idf)
      if (allocated(nenergyspreadpoints_idf)) deallocate(nenergyspreadpoints_idf)
      if (allocated(simmode_idf)) deallocate(simmode_idf)
      if (allocated(nsimulation_idf)) deallocate(nsimulation_idf)
      if (allocated(simdimensionx_idf)) deallocate(simdimensionx_idf)
      if (allocated(simdimensiony_idf)) deallocate(simdimensiony_idf)
      if (allocated(nsimpoints_idf)) deallocate(nsimpoints_idf)

      idf_ok=.true.
1001  continue
	return
	end

c-----------------------------------------------------------------------
	subroutine deallocate_idf_all
      !DEC$ ATTRIBUTES DLLEXPORT::deallocate_idf_all
c     routine that deallocates all the idf related variables, including IDF tags and auxiliary variables
	use IDFCOM
	implicit none
	integer i,j,k,k1
c-----------------------------------------------------------------------
      idf_ok=.false.
      idf_error=' '

c     IDF tags
c     elementsandmolecules
	if (allocated(sample%elementsandmolecules%elements%element)) deallocate(sample%elementsandmolecules%elements%element)
	if (allocated(sample%elementsandmolecules%molecules%molecule)) deallocate(sample%elementsandmolecules%molecules%molecule)
c     structure - layeredstructure - layer
      if (allocated(sample%structure%layeredstructure%layers%layer)) deallocate(sample%structure%layeredstructure%layers%layer)
c     pointbypointstructure - pbp_aux
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%x)
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%xerror)
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%y)
      if (allocated(pbp_aux%x)) deallocate(pbp_aux%yerror)
c     element
      if (allocated(sample%structure%pointbypointstructure%pbpelement))deallocate(sample%structure%pointbypointstructure%pbpelement)
c     spectrum
      if (allocated(sample%spectra%spectrum)) deallocate(sample%spectra%spectrum)

c     from allocate_secondary_variables_idf
      if (allocated(nbeamfoillayers_idf)) deallocate(nbeamfoillayers_idf)
      if (allocated(nstoppingfoillayers_idf)) deallocate(nstoppingfoillayers_idf)
      if (allocated(nbeamchargestate_idf)) deallocate(nbeamchargestate_idf)
      if (allocated(nbeamfoilels_idf)) deallocate(nbeamfoilels_idf)
      if (allocated(nstoppingfoilels_idf)) deallocate(nstoppingfoilels_idf)
      if (allocated(npbp_idf)) deallocate(npbp_idf)
      if (allocated(nlayerspbp_idf)) deallocate(nlayerspbp_idf)
      if (allocated(nslitsaftersample_idf)) deallocate(nslitsaftersample_idf)
      if (allocated(nslitsbeforesample_idf)) deallocate(nslitsbeforesample_idf)
      if (allocated(ndeadlayer_idf)) deallocate(ndeadlayer_idf)
      if (allocated(ndeadlayerels_idf)) deallocate(ndeadlayerels_idf)
      if (allocated(nentrancewindow_idf)) deallocate(nentrancewindow_idf)
      if (allocated(nentrancewindowels_idf)) deallocate(nentrancewindowels_idf)
      if (allocated(ndetectorlayers_idf)) deallocate(ndetectorlayers_idf)
      if (allocated(ndetectorlayersels_idf)) deallocate(ndetectorlayersels_idf)
      if (allocated(ntofstartfoil_idf)) deallocate(ntofstartfoil_idf)
      if (allocated(ntofstartfoilels_idf)) deallocate(ntofstartfoilels_idf)
      if (allocated(ntofstopfoil_idf)) deallocate(ntofstopfoil_idf)
      if (allocated(ntofstopfoilels_idf)) deallocate(ntofstopfoilels_idf)
      if (allocated(ndetectorefficiency_idf)) deallocate(ndetectorefficiency_idf)
      if (allocated(ndetectorefficiencyentries_idf)) deallocate(ndetectorefficiencyentries_idf)
      if (allocated(efficiencymode_idf)) deallocate(efficiencymode_idf)
      if (allocated(ndetectorresolution_idf)) deallocate(ndetectorresolution_idf)
      if (allocated(nresolutionparameter_idf)) deallocate(nresolutionparameter_idf)
      if (allocated(nenergycalibration_idf)) deallocate(nenergycalibration_idf)
      if (allocated(ncalibrationparameter_idf)) deallocate(ncalibrationparameter_idf)
      if (allocated(nreaction_idf)) deallocate(nreaction_idf)
      if (allocated(ndatapoints_idf)) deallocate(ndatapoints_idf)
      if (allocated(ndatatimestamp_idf)) deallocate(ndatatimestamp_idf)
      if (allocated(ndataline_idf)) deallocate(ndataline_idf)
      if (allocated(datadimensionx_idf)) deallocate(datadimensionx_idf)
      if (allocated(datadimensiony_idf)) deallocate(datadimensiony_idf)
      if (allocated(datamode_idf)) deallocate(datamode_idf)
      if (allocated(nsimulation_idf)) deallocate(nsimulation_idf)
      if (allocated(ncrosssection_idf)) deallocate(ncrosssection_idf)
      if (allocated(ncrosssectionpoints_idf)) deallocate(ncrosssectionpoints_idf)
      if (allocated(nstoppingpower_idf)) deallocate(nstoppingpower_idf)
      if (allocated(nstoppingpowerpoints_idf)) deallocate(nstoppingpowerpoints_idf)
      if (allocated(nenergyspread_idf)) deallocate(nenergyspread_idf)
      if (allocated(nenergyspreadpoints_idf)) deallocate(nenergyspreadpoints_idf)
      if (allocated(simmode_idf)) deallocate(simmode_idf)
      if (allocated(nsimulation_idf)) deallocate(nsimulation_idf)
      if (allocated(simdimensionx_idf)) deallocate(simdimensionx_idf)
      if (allocated(simdimensiony_idf)) deallocate(simdimensiony_idf)
      if (allocated(nsimpoints_idf)) deallocate(nsimpoints_idf)

c     from define_tags_idf
      if (allocated(idfnchildren)) deallocate(idfnchildren)
      if (allocated(idfnattr)) deallocate(idfnattr)
      if (allocated(idfchildren)) deallocate(idfchildren)
      if (allocated(idfattr)) deallocate(idfattr)
      if (allocated(idftags)) deallocate(idftags)
      if (allocated(idfopentags)) deallocate(idfopentags)
      if (allocated(idfopennamespace)) deallocate(idfopennamespace)
      if (allocated(idfnamespaces)) deallocate(idfnamespaces)
      if (allocated(idfcontenttype)) deallocate(idfcontenttype)
      if (allocated(idfcontentallowed)) deallocate(idfcontentallowed)
      if (allocated(idfncontentallowed)) deallocate(idfncontentallowed)
      if (allocated(idfquantitytype)) deallocate(idfquantitytype)
      if (allocated(idfflaggroup)) deallocate(idfflaggroup)
      if (allocated(idf_tagopen)) deallocate(idf_tagopen)
      if (allocated(idftagquantities)) deallocate(idftagquantities)
      if (allocated(nslitsbeforesample_idf)) deallocate(nslitsbeforesample_idf)
      if (allocated(idfambiguous)) deallocate(idfambiguous)
      if (allocated(idfambiguousparent)) deallocate(idfambiguousparent)

c     from define_units_idf
      if (allocated(idfquantities)) deallocate(idfquantities)
      if (allocated(idfunits)) deallocate(idfunits)
      if (allocated(idfnunits)) deallocate(idfnunits)

      idf_ok=.true.
	return
	end


